package core 
{
	import starling.display.DisplayObject;
	
	/**
	 * ...
	 * @author miyijura
	 */
	public class GamePool 
	{
		//creamos una variable tipo array que servira para guardar y administrar los objetos creados
		private var pool:Array;
		//esta variable numerica servira para saber cuantos objetos existen
		private var counter:int;
		
		public function GamePool(type:Class, len:int) 
		{
			//creamos el nuevo array
			pool = new Array();
			//el valor de counter es pasado desde len el argumento en el constructor
			counter = len;
			
			//empezamos con la iteracion de objetos
			//la variable local i representa el indice de len
			var i:int = len;
			//simple while que crea los objetos...
			//decrementamos en cada iteracion el valor de i 
			while (--i > -1)
			//el objeto es creado en el array y se le asigna una clase de acuerdo al tipo espedificado (lasers, enemigos, etc.)
			pool[i] = new type();
		}
		
		//iniciamos con setters y getters
		
		//esta funcion toma el sprite creado
		public function getSprite():DisplayObject
		{
			//si el counter es mayor a 0
			if (counter > 0)
				//devolvemos un objeto del pool y decrementamos el valor de counter 1 unidad
				return pool[--counter];
			//si la definicion anterior no se cumple
			else
				//enviamos un mensaje de error a la consola
				//o puedes crear alguna funcionalidad para tu juego, como tiempo de recarga, etc.
				throw new Error("No hay mas objetos. Pool agotado!");
		}
		
		//esta funcion regresa el objeto al contenedor de objetos para reutilizarlo
		public function returnSprite(s:DisplayObject):void //usamos una variable tipo DisplayObject como argumento
		{
			//regresamos el objeto al contenedor general
			pool[counter++] = s;
		}
		
		//metodo para limpiar los objetos del pool
		public function destroy():void {
			//destruimos los objetos
			pool = null;
		}
		
	}

}